/*	$ DOOROOS: Gd_main.c v 0.1 2003/07/14 $	*/

/*
 * Copyright (C) 2003	iBOSN systems
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are not permitted completely.
 *
 */

/*
 * Module Name: Gd_main.c
 *
 * Purpose: graphic system driver interfaace functions.
 *          
 *
 */

#include <types.h>

#include <window.h>
#include <memory.h>
#include <device.h>
#include <gl\gl.h>
#include <dev\gd.h>
#include <lib\string.h>

#include <mach/SAMA5D3X.h>
#include <dev\drvlib.h>

#include <gl\sdi.h>
#include "drv_display.h"

#include <dev/displaydrv.h>
#include <dev/drvlib.h>

#include <cache.h>
#include <panic.h>


#define DMA_ADDR_OFFSET         0x20000000


#define DBG_LVL_LCD     0

#ifdef _HOOKRECT_
static  void (*pHookInvalidateRect)(RECT *pRect);
#endif


EXTERN VOID GD_PowerOff( VOID );
EXTERN VOID GD_PowerOn( VOID );

EXTERN VOID GD_Contrast( UINT32 nContrast );
EXTERN BOOL DisplayInit( CHANNELINFO *pChannelInfo );//UINT32 Channel, UINT32 FrameBuffer, INT32 x, INT32 y, INT32 w, INT32 h );

EXTERN VOID DisplayEnableLayer( CHANNELINFO *pChannelInfo );
EXTERN VOID DisplayEnableTransparent( CHANNELINFO *pChannelInfo );
EXTERN VOID DisplayEnableAlpha( CHANNELINFO *pChannelInfo );

CHANNELINFO ChannelInfo[CHANNEL_MAX];

#define R_MASK  0x0000FF
#define G_MASK  0x00FF00
#define B_MASK  0xFF0000

STATIC BOOL GD_DisplayDrvControl( UINT32 No, PUINT32 pData );

//#define DEFAULT_ROTATE  0
//#define DEFAULT_ROTATE  90
//#define DEFAULT_ROTATE  180
//#define DEFAULT_ROTATE  270
PUBLIC UINT32 RotateAngle = DEFAULT_ROTATE;
PSHARED_MEMORY  pSharedMemory = (PSHARED_MEMORY)SHARED_MEMORY_BASE;

/* 
 * set to the default value
 */
STATIC VOID
ChannelInit(VOID)
{
    INT32       i;
    PSDI        pSDI;

    memset( ChannelInfo, 0, sizeof(ChannelInfo) );
    for( i = 0; i < CHANNEL_MAX; i++ )
    {
        ChannelInfo[i].Channel = i;

        ChannelInfo[i].xOff = 0;
        ChannelInfo[i].yOff = 0;

        if( i == CHANNEL_BASE )
        {
            ChannelInfo[i].Width  = DISPLAY_WIDTH;
            ChannelInfo[i].Height = DISPLAY_HEIGHT;
            ChannelInfo[i].cTransparent = DEFAULT_TRANSPARENT_COLOR;   // default transparent color
        }
        else
        {
            ChannelInfo[i].Width  = DISPLAY_WIDTH;
            ChannelInfo[i].Height = DISPLAY_HEIGHT;
            ChannelInfo[i].cTransparent = DEFAULT_TRANSPARENT_COLOR;   // default transparent color
        }

        pSDI = &ChannelInfo[i].Frame;
        pSDI->Xres       = DISPLAY_WIDTH;
        pSDI->Yres       = DISPLAY_HEIGHT;
        pSDI->nStride    = DISPLAY_STRIDE;

        pSDI->nBpp       = 32;  // 32 bpp
        pSDI->Addr       = 0;
        pSDI->pDraw      = &Func_SDI32;

        pSDI->BitMask[0] = R_MASK;  // R : 8
        pSDI->BitMask[1] = G_MASK;  // G : 8
        pSDI->BitMask[2] = B_MASK;  // B : 8
                                        //{0xF800, 0x07E0, 0x001F}		// R,G,B : 565
                                        
        pSDI = &ChannelInfo[i].Intf;

#if (DEFAULT_ROTATE==90) || (DEFAULT_ROTATE==270)
        {
            pSDI->Xres       = DISPLAY_HEIGHT;//DISPLAY_WIDTH;
            pSDI->Yres       = DISPLAY_WIDTH;//DISPLAY_HEIGHT;
            pSDI->nStride    = pSDI->Xres*4;//DISPLAY_STRIDE;
            //pSDI->Xres       = DISPLAY_WIDTH;
            //pSDI->Yres       = DISPLAY_HEIGHT;
            //pSDI->nStride    = DISPLAY_STRIDE;
        }
#else
        {
            pSDI->Xres       = DISPLAY_WIDTH;
            pSDI->Yres       = DISPLAY_HEIGHT;
            pSDI->nStride    = DISPLAY_STRIDE;
        }
#endif
        pSDI->nBpp       = 32;  // 32 bpp
        pSDI->Addr       = 0;
        pSDI->pDraw      = &Func_SDI32;

        pSDI->BitMask[0] = R_MASK;  // R : 8
        pSDI->BitMask[1] = G_MASK;  // G : 8
        pSDI->BitMask[2] = B_MASK;  // B : 8
                                        //{0xF800, 0x07E0, 0x001F}		// R,G,B : 565
    }

    return;
}



#ifdef _USE_THREAD_DRIVER_
STATIC HANDLE   hDisplay = NULL;
#define MESSAGE_DEVICE_DSP                      (32+32)
#define IOCTRL_DSP_INVALIDATERECT           MESSAGE_DEFINITION(MESSAGE_DEVICE, MESSAGE_DEVICE_DSP, 1)
#define IOCTRL_DSP_DRVCONTROL               MESSAGE_DEFINITION(MESSAGE_DEVICE, MESSAGE_DEVICE_DSP, 2)

struct _INVALIDATE_RECT_PARAM_
{
    UINT32  Channel;
    PRECT   pRect;
};

struct _DRVCONTROL_PARAM_
{
    UINT32  No;
    VOID *  pData;
};

STATIC VOID
CopyRect( UINT32 Channel )
{
#if 0
    INT32       h;
    INT32       w;
    PBYTE       pDst;
    PBYTE       pSrc;

    CHANNELINFO *pChannelInfo = ChannelInfo + Channel;
    PRECT   pRect = &pChannelInfo->Rect;

    /* check the rectangle area validation */
    if( pRect->Xmin > pRect->Xmax )
        return;

    pDst = ((PUINT8)(pChannelInfo->Frame.Addr)) + pRect->Ymin * (DISPLAY_STRIDE) + (pRect->Xmin<<2);
    pSrc = ((PUINT8)(pChannelInfo->Intf.Addr))  + pRect->Ymin * (DISPLAY_STRIDE) + (pRect->Xmin<<2);

    w = pRect->Xmax - pRect->Xmin + 1;
    w = (w<<2);
    for( h = pRect->Ymin; h <= pRect->Ymax; h++)
    {
        memcpy( pDst, pSrc, w );

        pDst += (DISPLAY_STRIDE);
        pSrc += (DISPLAY_STRIDE);
    }

    //CacheRangeFlush(pChannelInfo->Frame.Addr, DISPLAY_STRIDE*DISPLAY_HEIGHT, CP15_SYNC_DISCARD|CP15_SYNC_L2_DISCARD);
    CP15_coherent_dcache_for_dma( (char *)pChannelInfo->Frame.Addr, (char *)pChannelInfo->Frame.Addr + DISPLAY_STRIDE*DISPLAY_HEIGHT);

    // reset 
    pRect->Xmin = DISPLAY_WIDTH;
    pRect->Ymin = DISPLAY_HEIGHT;
    pRect->Xmax = 0;
    pRect->Ymax = 0;

#else
    // 90 degree rotation

#if 1
    INT32       h;
    INT32       w;
    INT32       Offset;

    UINT32*     pDst;
    UINT32*     pSrc;
    UINT32      sFlush;
 
    CHANNELINFO *pChannelInfo = ChannelInfo + Channel;
    PRECT   pRect = &pChannelInfo->Rect;

    /* check the rectangle area validation */
    if( pRect->Xmin > pRect->Xmax )
        return;
 
    //Offset = DISPLAY_HEIGHT - (pRect->Xmax - pRect->Xmin + 1);
    //pSrc = ((UINT32*)(pChannelInfo->Intf.Addr)) + pRect->Ymin * DISPLAY_HEIGHT + pRect->Xmin;
    Offset = DISPLAY_WIDTH - (pRect->Ymax - pRect->Ymin + 1);
    pDst = (UINT32*)pChannelInfo->Frame.Addr + pRect->Xmin * DISPLAY_WIDTH + (DISPLAY_WIDTH - pRect->Ymax);

    sFlush = (UINT32)pDst;

    for (w = pRect->Xmin; w <= pRect->Xmax; w++)
//    {
//        pSrc = ((UINT32*)(pChannelInfo->Intf.Addr)) + pRect->Ymin * DISPLAY_HEIGHT + (DISPLAY_HEIGHT - 1 - w);
//    for (w = pRect->Xmax; w >= pRect->Xmin; w--)
    {
        pSrc = ((UINT32*)(pChannelInfo->Intf.Addr)) + pRect->Ymax * DISPLAY_HEIGHT + (w);
        //pSrc = ((UINT32*)(pChannelInfo->Intf.Addr)) + pRect->Ymin * DISPLAY_HEIGHT + (w);
        //pSrc = ((UINT32*)(pChannelInfo->Intf.Addr)) + pRect->Ymin * DISPLAY_HEIGHT + (DISPLAY_HEIGHT - 1 - w);

//        pDst = pDstBase + pRect->Xmin * DISPLAY_WIDTH + (DISPLAY_WIDTH-1-h);
//        pDst = ((UINT32*)(pChannelInfo->Frame.Addr)) + pRect->Xmin * DISPLAY_WIDTH + (h);
//        pDst = ((UINT32*)(pChannelInfo->Frame.Addr)) + pRect->Xmin * DISPLAY_WIDTH + (h);


        for( h = pRect->Ymin; h <= pRect->Ymax; h++)
        {
            *pDst = *pSrc;
 
            pSrc -= DISPLAY_HEIGHT;
            pDst++;
        }

        if( (w & 1) )
        {
            CP15_coherent_dcache_for_dma ( (UINT32)sFlush, (UINT32)pDst);
            sFlush = (UINT32)pDst;
        }

        //CP15_flush_dcache_for_dma ( (UINT32)sFlush, (UINT32)pDst);
        pDst += Offset;
    }

            CP15_coherent_dcache_for_dma ( (UINT32)sFlush, (UINT32)pDst);
    //CacheRangeFlush(pChannelInfo->Frame.Addr, DISPLAY_STRIDE*DISPLAY_HEIGHT, CP15_SYNC_WRITEBACK);
//    CacheRangeFlush(pChannelInfo->Frame.Addr, DISPLAY_STRIDE*DISPLAY_HEIGHT, CP15_SYNC_DISCARD|CP15_SYNC_L2_DISCARD);

    // reset 
    pRect->Xmin = DISPLAY_WIDTH;
    pRect->Ymin = DISPLAY_HEIGHT;
    pRect->Xmax = 0;
    pRect->Ymax = 0;
#else
    INT32       h;
    INT32       w;
    INT32       Offset;
    UINT32*     pDstBase;
    UINT32*     pDst;
    UINT32*     pSrc;
 
    CHANNELINFO *pChannelInfo = ChannelInfo + Channel;
    PRECT   pRect = &pChannelInfo->Rect;

    /* check the rectangle area validation */
    if( pRect->Xmin > pRect->Xmax )
        return;
 
    Offset = DISPLAY_HEIGHT - (pRect->Xmax - pRect->Xmin + 1);
    pSrc = ((UINT32*)(pChannelInfo->Intf.Addr)) + pRect->Ymin * DISPLAY_HEIGHT + pRect->Xmin;
    pDstBase = (UINT32*)pChannelInfo->Frame.Addr;
    for( h = pRect->Ymin; h <= pRect->Ymax; h++)
    {
        pDst = pDstBase + pRect->Xmin * DISPLAY_WIDTH + (DISPLAY_WIDTH-1-h);
//        pDst = ((UINT32*)(pChannelInfo->Frame.Addr)) + pRect->Xmin * DISPLAY_WIDTH + (h);
//        pDst = ((UINT32*)(pChannelInfo->Frame.Addr)) + pRect->Xmin * DISPLAY_WIDTH + (h);
        for (w = pRect->Xmin; w <= pRect->Xmax; w++)
        {
//            UINT32 vPixel;
//            vPixel = *pSrc;
//
//            *pDst = vPixel;
            *pDst = *pSrc;
 
            pSrc++;
            pDst += DISPLAY_WIDTH;
        }

        pSrc += Offset;
    }

    //CacheRangeFlush(pChannelInfo->Frame.Addr, DISPLAY_STRIDE*DISPLAY_HEIGHT, CP15_SYNC_WRITEBACK);
    CP15_coherent_dcache_for_dma( (char *)pChannelInfo->Frame.Addr, (char *)pChannelInfo->Frame.Addr + DISPLAY_STRIDE*DISPLAY_HEIGHT);
//    CacheRangeFlush(pChannelInfo->Frame.Addr, DISPLAY_STRIDE*DISPLAY_HEIGHT, CP15_SYNC_DISCARD|CP15_SYNC_L2_DISCARD);

    // reset 
    pRect->Xmin = DISPLAY_WIDTH;
    pRect->Ymin = DISPLAY_HEIGHT;
    pRect->Xmax = 0;
    pRect->Ymax = 0;
#endif

#endif

    return;
}

STATIC VOID
RectSuper( UINT32 Channel, PRECT pRect )
{
    CHANNELINFO *pChannelInfo = ChannelInfo + Channel;

    PRECT pRectSuper;

    pRectSuper = &pChannelInfo->Rect;
    if( pRectSuper->Xmin > pRect->Xmin )
        pRectSuper->Xmin = pRect->Xmin;

    if( pRectSuper->Ymin > pRect->Ymin )
        pRectSuper->Ymin = pRect->Ymin;

    if( pRectSuper->Xmax < pRect->Xmax )
        pRectSuper->Xmax = pRect->Xmax;

    if( pRectSuper->Ymax < pRect->Ymax )
        pRectSuper->Ymax = pRect->Ymax;

    return;
}


STATIC INT32
th_Display( UINT32 Arg )
{
    JB_RECVMESSAGE      Message;
    HANDLE              hPort;
    HANDLE              Handle = NULL;
    PDEVICECONFIG       pDeviceConfig;
    UINT32              nSysIntrDsp;

//    RECT                Rect;
//            Rect.Xmin = DISPLAY_WIDTH;
//            Rect.Ymin = DISPLAY_HEIGHT;
//            Rect.Xmax = 0;
//            Rect.Ymax = 0;

    pDeviceConfig = (PDEVICECONFIG)Arg;
    
    hPort = PortGet( );    
    PortSetType( hPort, PORTTYPE_MESSAGE|PORTTYPE_INTERRUPT|PORTTYPE_SIGNAL );

    pDeviceConfig->Name[3] = (UINT32)pDeviceConfig->Minor + '1';
    pDeviceConfig->Channel = ChannelGet( hPort );
    DeviceRegister( (PDEVICECONFIG)pDeviceConfig );

{
    SYSINTR_REQUEST     SysIntrRequest;

    // request sysintr    
    SysIntrRequest.nHalIrq = SAMA5D3_ID_LCDC;
    SysIntrRequest.BitMap = 0;
    SysIntrRequest.Flag = SYSINTR_REQ_FLAG_STATIC;

    if( !KernelIoControl( IOCTRL_HAL_SYSINTR_REQUEST, 
                          &SysIntrRequest, 
                          sizeof( SYSINTR_REQUEST ), 
                          &nSysIntrDsp,
                          sizeof(UINT32) ) )
    {
        DEBUGMSG( 1,"%s (%d): nSysIntrTouch = %d\n", __FUNCTION__, __LINE__, nSysIntrDsp );
        return 0;
    }
}
    InterruptRegister( nSysIntrDsp, hPort);


    AT91PS_LCDC pLCDC = (AT91PS_LCDC)AT91C_BASE_LCDC;
    //DisplayInit(pFrameBuffer);
    {
        pLCDC->LCDC_LCDIER = LCDC_LCDIER_BASEIE;
        pLCDC->LCDC_BASEIER = LCDC_BASEIER_DMA;
        InterruptEnable( nSysIntrDsp );
    }

int nInt = 0;
    while(1)
	{
		MessageReceive( hPort, &Message);
		//kprintf("%s(%d):Message.Type=%x\n",__FUNCTION__,__LINE__,Message.Type);

		switch(Message.Type)
		{
		case MESSAGE_TYPE_INTERRUPT:
		{
		    //PGD     pGD;
            //
            //InterruptDisable( nSysIntrDsp);

            //pLCDC->LCDC_BASEIDR = LCDC_BASEIER_DMA;
            VOLATILE UINT32 LcdIsr = pLCDC->LCDC_BASEISR;

            /* search all channel */
            CopyRect( 0 );

            //*(PREG)(SPEAR320_CLCD_BASE + CLCD_ICLR) = *(PREG)(SPEAR320_CLCD_BASE + CLCD_STAT);
            InterruptDone( nSysIntrDsp);
            continue;
		}

		case MESSAGE_TYPE_SIGNAL:
		{
            continue;
		}

		case MESSAGE_TYPE_DEVICE_CONTROL:
	    {
            //PRECT   pRect;
            PIOCONTROL_PARAM    pIoControlParam;

            pIoControlParam = (PIOCONTROL_PARAM)Message.Param;

            Message.Type = TRUE;
		    switch( pIoControlParam->Cmd )
		    {
		    case IOCTRL_DSP_INVALIDATERECT:
            {
                struct _INVALIDATE_RECT_PARAM_ *pInvalParam;
                pInvalParam = (struct _INVALIDATE_RECT_PARAM_ *)pIoControlParam->pInBuf;
                RectSuper( pInvalParam->Channel, pInvalParam->pRect );

                AT91PS_LCDC pLCDC = (AT91PS_LCDC)AT91C_BASE_LCDC;
                pLCDC->LCDC_LCDIER = LCDC_LCDIER_BASEIE;
                pLCDC->LCDC_BASEIER = LCDC_BASEIER_DMA;
                InterruptEnable( nSysIntrDsp );
                break;
            }

            case IOCTRL_DSP_DRVCONTROL:
            {
                struct _DRVCONTROL_PARAM_   *pDrvControl;
                
                pDrvControl = (struct _DRVCONTROL_PARAM_ *) pIoControlParam->pInBuf;
                Message.Type = GD_DisplayDrvControl( pDrvControl->No, pDrvControl->pData );
                break;
            }

            default:
                Message.Type = FALSE;
                break;
            }

			break;
	    }

		case MESSAGE_TYPE_DEVICE_READ:
        {
		    Message.Type = 0;
			break;
	    }

		case MESSAGE_TYPE_DEVICE_WRITE:
	    {
            Message.Type = 0;
            break;
	    }

		case MESSAGE_TYPE_DEVICE_OPEN:
        {
            Handle = ChannelOpenHandleGetFrom( pDeviceConfig->Channel );
            Message.Type = Handle;
            break;
        }

		case MESSAGE_TYPE_DEVICE_CLOSE:
        {
		    Message.Type = TRUE;
			break;
	    }

        default:
            break;
		}

        MessageReply(&Message);

	}

	return TRUE;	
}

//==========================================================================
#define DISPLAY_STACK_SIZE      (4096)

STATIC DEVICECONFIG             DisplayDeviceConfig ={"DSP", 0, -1, NULL, NULL };

STATIC THREADCONFIG             DisplayDev_Thread =
                                            {
                                                (UINT32)&DisplayDeviceConfig,
                                                th_Display,
                                                (PBYTE)NULL,
                                                DISPLAY_STACK_SIZE,
                                                THREAD_PRIORITY_DRIVER_HIGH+10
                                            };
//==========================================================================


STATIC BOOL
GD_Init( UINT32 Channel )
{
    UINT32  Frame;
    UINT32  Intf;

//DBGLINE(1,"Channel = %x\n", Channel);
    CHANNELINFO *pChannelInfo = ChannelInfo + Channel;

    UINT32 nPage = (DISPLAY_STRIDE * DISPLAY_HEIGHT + MEMPOOL_SIZE - 1)>>MEMPOOL_SHIFT;
//DBGLINE(1,"nPage = %x\n", nPage);

    Frame = (UINT32)MemPageAllocEx(nPage+2);
    Intf  = (UINT32)MemPageAllocEx(nPage+2);

    pChannelInfo->Frame.Addr = Frame;
    pChannelInfo->Intf.Addr  = Intf;

    pChannelInfo->bOn = TRUE;
    DisplayInit( pChannelInfo ); //Channel, Frame+DMA_ADDR_OFFSET, 0, 0, DISPLAY_WIDTH, DISPLAY_HEIGHT);

	DEBUGMSG(DBG_LVL_LCD,"%s(%d): Intf = %x\n",__FUNCTION__, __LINE__, Intf);
	DEBUGMSG(DBG_LVL_LCD,"%s(%d): Frame = %x\n",__FUNCTION__, __LINE__, Frame);

	return TRUE;
}

STATIC BOOL
GD_DeInit( PGD pGD, UINT32 Channel )
{
//DBGLINE(1,"Channel = %x\n", Channel);
    CHANNELINFO *pChannelInfo = ChannelInfo + Channel;

    MemPageFree((PVOID)pChannelInfo->Frame.Addr);
    MemPageFree((PVOID)pChannelInfo->Intf.Addr);
    return TRUE;
}

STATIC VOID
GD_InvalidateRect( PGD pGD, PRECT pRect, UINT32 Channel )
{
//kprintf("%s(%d:hDisplay=%x\n",__FUNCTION__,__LINE__,hDisplay);
    struct _INVALIDATE_RECT_PARAM_  InvalParam;

    if( hDisplay == NULL )
        hDisplay = IoOpen( (PBYTE)"DSP1" );

    InvalParam.Channel = Channel;
    InvalParam.pRect = pRect;
    IoControl( hDisplay , IOCTRL_DSP_INVALIDATERECT, &InvalParam, sizeof(struct _INVALIDATE_RECT_PARAM_ *), NULL, NULL );
    return;
}

STATIC BOOL
GD_DisplayDrvControl_Base( UINT32 No, PUINT32 pData )
{
    BOOL    bRet;
    struct _DRVCONTROL_PARAM_  ControlParam;

    if( hDisplay == NULL )
        hDisplay = IoOpen( (PBYTE)"DSP1" );

    ControlParam.No = No;
    ControlParam.pData = pData;
    bRet = IoControl( hDisplay , IOCTRL_DSP_DRVCONTROL, &ControlParam, sizeof(struct _DRVCONTROL_PARAM_ *), NULL, NULL );

    return bRet;
}

#else

#define MAX_TRANSDESC   1000//20
static UINT32 nDmaChannelTx = DMAD_ALLOC_FAILED;
static HDMA_TRANSFER_DESC pTxTranDesc[MAX_TRANSDESC];
STATIC BOOL
GD_Init( UINT32 Channel )
{
    UINT32  Frame;
    UINT32  Intf;

//DBGLINE(1,"Channel = %x\n", Channel);
    CHANNELINFO *pChannelInfo = ChannelInfo + Channel;

    UINT32 nPage = (DISPLAY_STRIDE * DISPLAY_HEIGHT + MEMPOOL_SIZE - 1)>>MEMPOOL_SHIFT;
//DBGLINE(1,"nPage = %x\n", nPage);

    Frame = (UINT32)MemPageAllocEx(nPage+2);
    Intf  = (UINT32)MemPageAllocEx(nPage+2);

    pChannelInfo->Frame.Addr = Frame;
    pChannelInfo->Intf.Addr  = Intf;

    pChannelInfo->bOn = TRUE;
    DisplayInit( pChannelInfo ); //Channel, Frame+DMA_ADDR_OFFSET, 0, 0, DISPLAY_WIDTH, DISPLAY_HEIGHT);

	DEBUGMSG(DBG_LVL_LCD,"%s(%d): Intf = %x\n",__FUNCTION__, __LINE__, Intf);
	DEBUGMSG(DBG_LVL_LCD,"%s(%d): Frame = %x\n",__FUNCTION__, __LINE__, Frame);

    {
        // enable layer of cursor
        CHANNELINFO *pChannelInfo = ChannelInfo + CHANNEL_CURSOR;
        pChannelInfo->xOff = 0;
        pChannelInfo->yOff = 0;

        pChannelInfo->Width  = CURSOR_WIDTH;
        pChannelInfo->Height = CURSOR_HEIGHT;
        pChannelInfo->cTransparent = DEFAULT_TRANSPARENT_COLOR;   // default transparent color

        Frame = (UINT32)MemPageAllocEx(1);
        Intf  = (UINT32)MemPageAllocEx(1);

        FillCursorImage( Frame, 0, 0);
        
        pChannelInfo->Frame.Addr = Frame;
        pChannelInfo->Intf.Addr  = Intf;

        pChannelInfo->bOn = FALSE; //TRUE;

        SDI *pSDI;
        pSDI = &pChannelInfo->Frame;
        pSDI->Xres       = CURSOR_WIDTH;
        pSDI->Yres       = CURSOR_HEIGHT;
        pSDI->nStride    = CURSOR_WIDTH*4;

        DisplayEnableLayer( pChannelInfo );
        //LCDD_SetPosition( LCDD_SetPosition/*LCDD_CUR*/, 100, 200 );
    }

    {
        // enable layer of camera
        CHANNELINFO *pChannelInfo = ChannelInfo + CHANNEL_VIDEO;
        pChannelInfo->xOff = 0;
        pChannelInfo->yOff = 0;

        pChannelInfo->Width  = CAMERA_WIDTH;
        pChannelInfo->Height = CAMERA_HEIGHT;
        pChannelInfo->cTransparent = DEFAULT_TRANSPARENT_COLOR;   // default transparent color

        nPage = (CAMERA_HEIGHT * CAMERA_WIDTH*4 + MEMPOOL_SIZE - 1)>>MEMPOOL_SHIFT;
        Frame = (UINT32)MemPageAllocEx( nPage );
        Intf  = (UINT32)MemPageAllocEx( nPage );

        //FillCursorImage( Frame, 0, 0);
        pChannelInfo->Frame.Addr = Frame;
        pChannelInfo->Intf.Addr  = Intf;

        //pChannelInfo->bOn = TRUE;
        pChannelInfo->bOn = FALSE;

        SDI *pSDI;
        pSDI = &pChannelInfo->Frame;
        pSDI->Xres       = CAMERA_WIDTH;
        pSDI->Yres       = CAMERA_HEIGHT;
        pSDI->nStride    = CAMERA_WIDTH*4;

        DisplayEnableLayer( pChannelInfo );
        //LCDD_SetPosition( LCDD_SetPosition/*LCDD_CUR*/, 100, 200 );
    }

{
    if( nDmaChannelTx == DMAD_ALLOC_FAILED )
        nDmaChannelTx = DMAD_AllocateChannel(DMAD_TRANSFER_MEMORY, DMAD_TRANSFER_MEMORY, TRUE);

//DEBUGMSG(1, "%s (%d): nDmaChannelTx = %x\n",__FUNCTION__,__LINE__, nDmaChannelTx);
    if (nDmaChannelTx == DMAD_ALLOC_FAILED  )
    {
		DEBUGMSG(1, "%s (%d): DMA channel allocat error\n",__FUNCTION__,__LINE__);
        return FALSE;
    }

    /* Configure DMA TX channel */
    //iController = (nDmaChannelTx >> 3);
    UINT32 dwCfg = 0           
           //| DMAC_CFG_DST_PER(DMAIF_Get_ChannelNumber( iController, UartId, DMAD_TRANSFER_TX ))
           //| DMAC_CFG_DST_H2SEL
           //| DMAC_CFG_SOD
           //| DMAC_CFG_AHB_PROT(0xF)
           //| DMAC_CFG_FIFOCFG_HALF_CFG;
           | DMAC_CFG_FIFOCFG_ALAP_CFG;
    DMAD_PrepareChannel( nDmaChannelTx, dwCfg );
}

	return TRUE;
}

STATIC BOOL
GD_DeInit( PGD pGD, UINT32 Channel )
{
//DBGLINE(1,"Channel = %x\n", Channel);
    CHANNELINFO *pChannelInfo = ChannelInfo + Channel;

    MemPageFree((PVOID)pChannelInfo->Frame.Addr);
    MemPageFree((PVOID)pChannelInfo->Intf.Addr);
    return TRUE;
}


// No Rotation
STATIC VOID
GD_InvalidateRect_0( PGD pGD, PRECT pRect, UINT32 Channel )
{
    SDI *pSDI = pGD->pSDI;
#if 0
    INT32       h;
    INT32       w;

//kprintf("%s(%d): %d, %d, %d, %d\n", __FUNCTION__ ,__LINE__, pRect->Xmin, pRect->Ymin, pRect->Xmax, pRect->Ymax);

    w = pRect->Xmax - pRect->Xmin + 1;
    h = pRect->Ymax - pRect->Ymin + 1;

    PBYTE       pDst;
    PBYTE       pSrc;
    CHANNELINFO *pChannelInfo = ChannelInfo + Channel;
    pDst = ((PUINT8)(pChannelInfo->Frame.Addr)) + pRect->Ymin * (DISPLAY_STRIDE) + (pRect->Xmin<<2);
    pSrc = ((PUINT8)(pChannelInfo->Intf.Addr))  + pRect->Ymin * (DISPLAY_STRIDE) + (pRect->Xmin<<2);


//    DMAD_StopTransfer(nDmaChannelTx);
//    DMAD_ConfigurePIP( nDmaChannelTx, 
//                       DMAC_CTRLB_SRC_DSCR |
//                       DMAC_CTRLB_SRC_INCR_INCREMENTING |
//                       DMAC_CTRLB_SIF_AHB_IF0 |
//                       DMAC_CTRLB_SST_PIP |
//                       DMAC_CTRLB_FC_MEM2MEM_DMA_FC 
//                       ,
//                       DMAC_CTRLB_DST_DSCR |
//                       DMAC_CTRLB_DST_INCR_INCREMENTING |
//                       DMAC_CTRLB_DIF_AHB_IF2 |
//                       DMAC_CTRLB_DST_PIP 
//                        );
//
//w = 50;
    DMAD_SetSourcePip( nDmaChannelTx, (DISPLAY_WIDTH - w) /*hole*/, w+1/*boundary*/);
    DMAD_SetDestPip(   nDmaChannelTx, (DISPLAY_WIDTH - w) /*hole*/, w+1/*boundary*/);
    //DMAD_SetSourcePip( nDmaChannelTx, (DISPLAY_STRIDE - w)/4 /*hole*/, w/4/*boundary*/);
    //DMAD_SetDestPip(   nDmaChannelTx, (DISPLAY_STRIDE - w)/4 /*hole*/, w/4/*boundary*/);
    //DMAD_SetSourcePip( nDmaChannelTx, 100 /*hole*/, 100/*boundary*/);
    //DMAD_SetDestPip(   nDmaChannelTx, 100 /*hole*/, 100/*boundary*/);


//kprintf("%s(%d): pSrc = %x\n",__FUNCTION__,__LINE__, pSrc);
//kprintf("%s(%d): pDst = %x\n",__FUNCTION__,__LINE__, pDst);

	//HDMA_TRANSFER_DESC  *pTxTranDesc;
	
	//pTxTranDesc = &TxTranDesc;
	//UINT32  MaxLine = ((0xFFFF)/w);
	UINT32  MaxLine = ((0xFFFF)/DISPLAY_WIDTH);
	UINT32  Line = 0;
	
//pSrc = 0x10000 ; //pDst + 0x100;

    int timeout = 0;
    AT91PS_DMAC pDmac = (AT91PS_DMAC)AT91C_BASE_DMAC0;
    while( (pDmac->DMAC_CHSR & (1<<nDmaChannelTx)) && (timeout++ < 10))
        Sleep(1);

    //CacheRangeFlush((char *)pChannelInfo->Intf.Addr, DISPLAY_STRIDE*DISPLAY_HEIGHT, CP15_SYNC_DISCARD|CP15_SYNC_L2_DISCARD);
//    CacheRangeFlush((char *)pChannelInfo->Intf.Addr, DISPLAY_STRIDE*DISPLAY_HEIGHT, CP15_SYNC_WRITEBACK);
//    CacheRangeFlush((char *)pSrc + DMA_ADDR_OFFSET, DISPLAY_STRIDE*h, CP15_SYNC_WRITEBACK);


//    CP15_flush_dcache_for_dma( (UINT32)pChannelInfo->Intf.Addr, 
//                               ((UINT32)pChannelInfo->Intf.Addr) + DISPLAY_STRIDE*DISPLAY_HEIGHT);
    CP15_coherent_dcache_for_dma( (char *)pSrc, (char *)pSrc + DISPLAY_STRIDE*h);

//kprintf("%s(%d): Line = %x\n",__FUNCTION__,__LINE__, Line);

//    DMAD_StopTransfer(nDmaChannelTx);

    int i;
    for( i = 0; i < MAX_TRANSDESC && (Line < h); i++ )
    {
        UINT32  CurLine;
        if( h - Line < MaxLine )    CurLine = h - Line;
        else                        CurLine = MaxLine;
        pTxTranDesc[i].SrcAddr = (UINT32)(pSrc + DMA_ADDR_OFFSET + Line*DISPLAY_STRIDE);
        pTxTranDesc[i].DstAddr = (UINT32)(pDst + DMA_ADDR_OFFSET + Line*DISPLAY_STRIDE);
        pTxTranDesc[i].CtrlA   = CurLine*(w+1) |
                             DMAC_CTRLA_SRC_WIDTH_WORD |
                             DMAC_CTRLA_DST_WIDTH_WORD;
        pTxTranDesc[i].CtrlB   = //DMAC_CTRLB_SRC_DSCR | DMAC_CTRLB_DST_DSCR |
                             DMAC_CTRLB_FC_MEM2MEM_DMA_FC | //DMAC_CTRLB_FC_MEM2PER_DMA_FC |
                             DMAC_CTRLB_SRC_INCR_INCREMENTING |
                             DMAC_CTRLB_SRC_PIP |
                             DMAC_CTRLB_DST_PIP |
                             DMAC_CTRLB_DST_INCR_INCREMENTING;//FIXED;

        pTxTranDesc[i].DscAddr = (UINT32)&pTxTranDesc[i+1] + DMA_ADDR_OFFSET;
        Line += CurLine;
    }
//kprintf("%s(%d): i = %x\n",__FUNCTION__,__LINE__, i);
    
    if( i > 0 )
        pTxTranDesc[i-1].DscAddr = 0;

    CP15_coherent_dcache_for_dma( (char *)pTxTranDesc, (char *)pTxTranDesc + sizeof(HDMA_TRANSFER_DESC)*i);
	//CacheRangeFlush(pTxTranDesc, sizeof(HDMA_TRANSFER_DESC)*i, CP15_SYNC_WRITEBACK);
    if( i <= 1 )
    {
        DMAD_PrepareSingleTransfer( nDmaChannelTx, (HDMA_TRANSFER_DESC *)((UINT32)pTxTranDesc + DMA_ADDR_OFFSET) );
    }
    else
    {
	    DMAD_PrepareMultiTransfer(nDmaChannelTx, (HDMA_TRANSFER_DESC *)((UINT32)pTxTranDesc + DMA_ADDR_OFFSET));
	}
    //DMAD_StartTransfer( nDmaChannelTx );

    pDmac->DMAC_CHER |= DMAC_CHER_ENA0 << nDmaChannelTx;
//kprintf("%s(%d): pDst = %x\n",__FUNCTION__,__LINE__, pDst);



//#if 0
//
//    HDMA_TRANSFER_DESC  *pTxTranDesc;
//	HDMA_TRANSFER_DESC TxTranDesc;
//	pTxTranDesc = &TxTranDesc;
//
//    pTxTranDesc->SrcAddr = (UINT32)(pSrc + DMA_ADDR_OFFSET);
//    pTxTranDesc->DstAddr = (UINT32)(pDst + DMA_ADDR_OFFSET);
//    pTxTranDesc->CtrlA   = DMAC_CTRLA_BTSIZE( 0xFFFF )//(w*h)/4 )
//                            | DMAC_CTRLA_SRC_WIDTH_WORD 
//                            | DMAC_CTRLA_DST_WIDTH_WORD;
//    pTxTranDesc->CtrlB   = DMAC_CTRLB_SRC_DSCR | DMAC_CTRLB_DST_DSCR
//                    | DMAC_CTRLB_FC_MEM2MEM_DMA_FC
//                    | DMAC_CTRLB_SRC_INCR_INCREMENTING
//                    | DMAC_CTRLB_SIF_AHB_IF0
//                    | DMAC_CTRLB_SRC_PIP
//                    | DMAC_CTRLB_DIF_AHB_IF2
//                    | DMAC_CTRLB_DST_INCR_INCREMENTING
//                    | DMAC_CTRLB_DST_PIP
//                    ;
//    pTxTranDesc->DscAddr = 0;
//kprintf("%s(%d): pTxTranDesc = %x\n",__FUNCTION__,__LINE__, pTxTranDesc);
//kprintf("%s(%d): pTxTranDesc->SrcAddr = %x\n",__FUNCTION__,__LINE__, pTxTranDesc->SrcAddr);
//kprintf("%s(%d): pTxTranDesc->DstAddr = %x\n",__FUNCTION__,__LINE__, pTxTranDesc->DstAddr);
//kprintf("%s(%d): pTxTranDesc->CtrlA = %x\n",__FUNCTION__,__LINE__, pTxTranDesc->CtrlA);
//kprintf("%s(%d): pTxTranDesc->CtrlB = %x\n",__FUNCTION__,__LINE__, pTxTranDesc->CtrlB);
//kprintf("%s(%d): pTxTranDesc->DscAddr = %x\n",__FUNCTION__,__LINE__, pTxTranDesc->DscAddr);
//
////kprintf("%s(%d): pSerialData->nDmaChannelTx = %x\n",__FUNCTION__,__LINE__, pSerialData->nDmaChannelTx);
//
//	//CacheRangeFlush(pTxTranDesc, sizeof(HDMA_TRANSFER_DESC), CP15_SYNC_WRITEBACK);
//    DMAD_PrepareSingleTransfer( nDmaChannelTx, pTxTranDesc );
//DEBUGMSG(1, "%s (%d): nDmaChannelTx = %x\n",__FUNCTION__,__LINE__, nDmaChannelTx);
//
//    AT91PS_DMAC pDmac = (AT91PS_DMAC)AT91C_BASE_DMAC0;
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_SADDR = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_SADDR);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_DADDR = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_DADDR);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_DSCR = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_DSCR);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_CTRLA = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_CTRLA);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_CTRLB = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_CTRLB);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_CFG = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_CFG);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_SPIP = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_SPIP);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_DPIP = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_DPIP);
//
//    DMAD_StartTransfer( nDmaChannelTx);
//#endif

////for(;;)
//{
//DBGLINE(1,": pDmac->DMAC_EN = %x\n",pDmac->DMAC_EN);
//DBGLINE(1,": pDmac->DMAC_CHSR = %x\n",pDmac->DMAC_CHSR);
//    
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_SADDR = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_SADDR);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_DADDR = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_DADDR);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_DSCR = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_DSCR);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_CTRLA = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_CTRLA);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_CTRLB = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_CTRLB);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_CFG = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_CFG);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_SPIP = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_SPIP);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_DPIP = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_DPIP);
////    DMAD_Handler(nDmaChannelTx);
////    if( DMAD_IsTransferDone(nDmaChannelTx) )
////        break;
////Sleep(1000);    
//}

    //CacheRangeFlush((char *)pChannelInfo->Frame.Addr, DISPLAY_STRIDE*DISPLAY_HEIGHT, CP15_SYNC_DISCARD|CP15_SYNC_L2_DISCARD);

#else
{
    INT32       h;
    INT32       w;
//	AT91PS_HDMA pDmac;
//	INT32	i;

//	pDmac = (AT91PS_HDMA)AT91C_BASE_HDMA0;
//	for(i=0;i<7;i++)
//	{
//		DEBUGMSG(DBG_LVL_LCD,"%s(%d)pFrameBuffer %X,%X %X\n", __FUNCTION__ ,__LINE__,pFrameBuffer,pDmac->HDMA_CH[i].HDMA_SADDR,pDmac->HDMA_CH[i].HDMA_DADDR);
//	}
//	DEBUGMSG(DBG_LVL_LCD,"%s(%d)HDMA_CHSR = %X\n", __FUNCTION__ ,__LINE__,pDmac->HDMA_CHSR);
//kprintf("%s(%d): %d, %d, %d, %d\n", __FUNCTION__ ,__LINE__, pRect->Xmin, pRect->Xmax, pRect->Ymin, pRect->Ymax);
//DBGLINE(1,"Channel = %x\n", Channel);

    PBYTE       pDst;
    PBYTE       pSrc;
    PBYTE       pDstTemp;

    CHANNELINFO *pChannelInfo = ChannelInfo + Channel;

    pDst = ((PUINT8)(pChannelInfo->Frame.Addr)) + pRect->Ymin * (DISPLAY_STRIDE) + (pRect->Xmin<<2);
    pSrc = ((PUINT8)(pChannelInfo->Intf.Addr))  + pRect->Ymin * (pSDI->nStride) + (pRect->Xmin<<2);

    pDstTemp = pDst;

    w = pRect->Xmax - pRect->Xmin + 1;
    w = (w<<2);
    for( h = pRect->Ymin; h <= pRect->Ymax; h++)
    {
        memcpy( pDst, pSrc, w );
        CP15_coherent_dcache_for_dma( (char *)pDst, (char *)pDst + w);

        pDst += (DISPLAY_STRIDE);
        pSrc += (pSDI->nStride);
    }

    //CP15_coherent_dcache_for_dma( (char *)pDstTemp, (char *)pDstTemp + DISPLAY_STRIDE*h);
    //CacheRangeFlush((char *)pChannelInfo->Frame.Addr, DISPLAY_STRIDE*DISPLAY_HEIGHT, CP15_SYNC_DISCARD|CP15_SYNC_L2_DISCARD);
}
#endif
    return;
}

// rotation 90 degree
STATIC VOID
GD_InvalidateRect_90( PGD pGD, PRECT pRect, UINT32 Channel )
{
    
        SDI *pSDI = pGD->pSDI;
#if 1
    INT32       h;
    INT32       w;


    w = pRect->Xmax - pRect->Xmin + 1;
    //w = (w<<2);
    h = pRect->Ymax - pRect->Ymin + 1;

    PBYTE       pDst;
    PBYTE       pSrc;
    CHANNELINFO *pChannelInfo = ChannelInfo + Channel;

//kprintf("%s(%d): pSrc = %x\n",__FUNCTION__,__LINE__, pChannelInfo->Intf.Addr);
//kprintf("%s(%d): pDst = %x\n",__FUNCTION__,__LINE__, pChannelInfo->Frame.Addr);

    pDst = ((PUINT8)(pChannelInfo->Frame.Addr)) + (DISPLAY_HEIGHT - 1 - pRect->Xmax) * (DISPLAY_STRIDE) + (pRect->Ymin<<2);
    //pSrc = ((PUINT8)(pChannelInfo->Intf.Addr))  + pRect->Ymin * (DISPLAY_STRIDE) + (pRect->Xmin<<2);
    //pDst = ((PUINT8)(pChannelInfo->Frame.Addr)) + (DISPLAY_HEIGHT-pRect->Xmin) * (DISPLAY_STRIDE) + (pRect->Ymin<<2);
    pSrc = ((PUINT8)(pChannelInfo->Intf.Addr))  + pRect->Ymin * (DISPLAY_HEIGHT*4) + (pRect->Xmax<<2);

    pDst += DMA_ADDR_OFFSET;
    pSrc += DMA_ADDR_OFFSET;

//    DMAD_Handler(nDmaChannelTx);
    
//    DMAD_StopTransfer(nDmaChannelTx);
//    DMAD_ConfigurePIP( nDmaChannelTx, 
//                       DMAC_CTRLB_SRC_DSCR |
//                       DMAC_CTRLB_SRC_INCR_INCREMENTING |
//                       DMAC_CTRLB_SIF_AHB_IF0 |
//                       DMAC_CTRLB_SST_PIP |
//                       DMAC_CTRLB_FC_MEM2MEM_DMA_FC 
//                       ,
//                       DMAC_CTRLB_DST_DSCR |
//                       DMAC_CTRLB_DST_INCR_INCREMENTING |
//                       DMAC_CTRLB_DIF_AHB_IF2 |
//                       DMAC_CTRLB_DST_PIP 
//                        );
//
//w = 50;
    DMAD_SetSourcePip( nDmaChannelTx, (DISPLAY_HEIGHT - 1+1) /*hole*/, 1/*boundary*/);
    //DMAD_SetDestPip(   nDmaChannelTx, (DISPLAY_WIDTH - w) /*hole*/, w+1/*boundary*/);
    //DMAD_SetSourcePip( nDmaChannelTx, (DISPLAY_STRIDE - w)/4 /*hole*/, w/4/*boundary*/);
    //DMAD_SetDestPip(   nDmaChannelTx, (DISPLAY_STRIDE - w)/4 /*hole*/, w/4/*boundary*/);
    //DMAD_SetSourcePip( nDmaChannelTx, 100 /*hole*/, 100/*boundary*/);
    //DMAD_SetDestPip(   nDmaChannelTx, 100 /*hole*/, 100/*boundary*/);

//kprintf("%s(%d): pSrc = %x\n",__FUNCTION__,__LINE__, pSrc);
//kprintf("%s(%d): pDst = %x\n",__FUNCTION__,__LINE__, pDst);

	//HDMA_TRANSFER_DESC  *pTxTranDesc;
	
	//pTxTranDesc = &TxTranDesc;
	//UINT32  MaxLine = h;//((0xFFFF)/w);
	//UINT32  Line = 0;
	
//pSrc = 0x10000 ; //pDst + 0x100;

    //CacheRangeFlush((char *)pChannelInfo->Intf.Addr, DISPLAY_STRIDE*DISPLAY_HEIGHT, CP15_SYNC_DISCARD|CP15_SYNC_L2_DISCARD);
    //CacheRangeFlush((char *)pChannelInfo->Intf.Addr, DISPLAY_STRIDE*DISPLAY_HEIGHT, CP15_SYNC_WRITEBACK);
    CP15_coherent_dcache_for_dma( (char *)pChannelInfo->Intf.Addr, (char *)pChannelInfo->Intf.Addr + DISPLAY_STRIDE*DISPLAY_HEIGHT);

    #define MAX_TIMEOUT 0x100000
    INT32 Timeout ;
    AT91PS_DMAC pDmac = (AT91PS_DMAC)AT91C_BASE_DMAC0;
    Timeout = 0;
    while( pDmac->DMAC_CHSR & (1<<nDmaChannelTx)  && Timeout++ < MAX_TIMEOUT) ;//Sleep(1);

//return;
//    DMAD_StopTransfer(nDmaChannelTx);
//kprintf("%s(%d): nDmaChannelTx = %x\n",__FUNCTION__,__LINE__, nDmaChannelTx);
//kprintf("%s(%d): w = %x\n",__FUNCTION__,__LINE__, w);
//kprintf("%s(%d): h = %x\n",__FUNCTION__,__LINE__, h);

    int i;
    for( i = 0; i < w; i++ )
    {
        pTxTranDesc[i].SrcAddr = (UINT32)(pSrc - (i)*4);
        //pTxTranDesc[i].SrcAddr = (UINT32)(pSrc + (i)*4);
        pTxTranDesc[i].DstAddr = (UINT32)(pDst + (i)*DISPLAY_STRIDE);
        pTxTranDesc[i].CtrlA   = (h) |
                             DMAC_CTRLA_SRC_WIDTH_WORD |
                             DMAC_CTRLA_DST_WIDTH_WORD;
        pTxTranDesc[i].CtrlB   = //DMAC_CTRLB_SRC_DSCR | DMAC_CTRLB_DST_DSCR |
                             DMAC_CTRLB_FC_MEM2MEM_DMA_FC | //DMAC_CTRLB_FC_MEM2PER_DMA_FC |
                             DMAC_CTRLB_SRC_INCR_INCREMENTING |
                             DMAC_CTRLB_SRC_PIP |
                             //DMAC_CTRLB_DST_PIP |
                             DMAC_CTRLB_DST_INCR_INCREMENTING;//FIXED;
//{
//    int j;
//    UINT32 *q = (UINT32 *)pTxTranDesc[i].SrcAddr;
//    UINT32 *p = (UINT32 *)pTxTranDesc[i].DstAddr;
//    if( i == 0 )
//    {
//        for(j = 0;j < h;j++){*q = 0x00FFFF00;q += DISPLAY_HEIGHT;}
//    }
//    else
//    for(j = 0;j < h;j++){*p++ = *q; q += DISPLAY_HEIGHT;}
//}
        pTxTranDesc[i].DscAddr = (UINT32)&pTxTranDesc[i+1] + DMA_ADDR_OFFSET;
//kprintf("%s(%d): %d : %x, %x\n",__FUNCTION__,__LINE__, i, pTxTranDesc[i].SrcAddr, pTxTranDesc[i].DstAddr);
    }


    if( i <= 0 )
        return;

    pTxTranDesc[i-1].DscAddr = 0;

	//CacheRangeFlush(pTxTranDesc, sizeof(HDMA_TRANSFER_DESC)*i, CP15_SYNC_WRITEBACK);
    CP15_coherent_dcache_for_dma( (char *)pTxTranDesc, (char *)pTxTranDesc + sizeof(HDMA_TRANSFER_DESC)*i);


    if( i <= 1 ) 
        DMAD_PrepareSingleTransfer( nDmaChannelTx, (HDMA_TRANSFER_DESC *)((UINT32)pTxTranDesc + DMA_ADDR_OFFSET) );
    else
        DMAD_PrepareMultiTransfer(nDmaChannelTx, (HDMA_TRANSFER_DESC *)((UINT32)pTxTranDesc + DMA_ADDR_OFFSET) );
//    DMAD_StartTransfer( nDmaChannelTx );

    pDmac->DMAC_CHER |= DMAC_CHER_ENA0 << nDmaChannelTx;

//kprintf("%s(%d): i = %d\n",__FUNCTION__,__LINE__, i);

//for(;;)
//{
//DBGLINE(1,": pDmac->DMAC_EN = %x\n",pDmac->DMAC_EN);
//DBGLINE(1,": pDmac->DMAC_CHSR = %x\n",pDmac->DMAC_CHSR);
//    
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_SADDR = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_SADDR);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_DADDR = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_DADDR);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_DSCR = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_DSCR);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_CTRLA = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_CTRLA);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_CTRLB = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_CTRLB);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_CFG = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_CFG);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_SPIP = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_SPIP);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_DPIP = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_DPIP);
//    DMAD_Handler(nDmaChannelTx);
//    if( !DMAD_IsTransferDone(nDmaChannelTx) )
//        break;
//Sleep(100);    
//}

//    // wait for completion of transfer.
//    Timeout = 0;
//    while( pDmac->DMAC_CHSR & (1<<nDmaChannelTx)  && Timeout++ < MAX_TIMEOUT) ;//Sleep(1);

//kprintf("%s(%d): i = %d\n",__FUNCTION__,__LINE__, i);

//#if 0
//
//    HDMA_TRANSFER_DESC  *pTxTranDesc;
//	HDMA_TRANSFER_DESC TxTranDesc;
//	pTxTranDesc = &TxTranDesc;
//
//    pTxTranDesc->SrcAddr = (UINT32)(pSrc + DMA_ADDR_OFFSET);
//    pTxTranDesc->DstAddr = (UINT32)(pDst + DMA_ADDR_OFFSET);
//    pTxTranDesc->CtrlA   = DMAC_CTRLA_BTSIZE( 0xFFFF )//(w*h)/4 )
//                            | DMAC_CTRLA_SRC_WIDTH_WORD 
//                            | DMAC_CTRLA_DST_WIDTH_WORD;
//    pTxTranDesc->CtrlB   = DMAC_CTRLB_SRC_DSCR | DMAC_CTRLB_DST_DSCR
//                    | DMAC_CTRLB_FC_MEM2MEM_DMA_FC
//                    | DMAC_CTRLB_SRC_INCR_INCREMENTING
//                    | DMAC_CTRLB_SIF_AHB_IF0
//                    | DMAC_CTRLB_SRC_PIP
//                    | DMAC_CTRLB_DIF_AHB_IF2
//                    | DMAC_CTRLB_DST_INCR_INCREMENTING
//                    | DMAC_CTRLB_DST_PIP
//                    ;
//    pTxTranDesc->DscAddr = 0;
//kprintf("%s(%d): pTxTranDesc = %x\n",__FUNCTION__,__LINE__, pTxTranDesc);
//kprintf("%s(%d): pTxTranDesc->SrcAddr = %x\n",__FUNCTION__,__LINE__, pTxTranDesc->SrcAddr);
//kprintf("%s(%d): pTxTranDesc->DstAddr = %x\n",__FUNCTION__,__LINE__, pTxTranDesc->DstAddr);
//kprintf("%s(%d): pTxTranDesc->CtrlA = %x\n",__FUNCTION__,__LINE__, pTxTranDesc->CtrlA);
//kprintf("%s(%d): pTxTranDesc->CtrlB = %x\n",__FUNCTION__,__LINE__, pTxTranDesc->CtrlB);
//kprintf("%s(%d): pTxTranDesc->DscAddr = %x\n",__FUNCTION__,__LINE__, pTxTranDesc->DscAddr);
//
////kprintf("%s(%d): pSerialData->nDmaChannelTx = %x\n",__FUNCTION__,__LINE__, pSerialData->nDmaChannelTx);
//
//	//CacheRangeFlush(pTxTranDesc, sizeof(HDMA_TRANSFER_DESC), CP15_SYNC_WRITEBACK);
//    DMAD_PrepareSingleTransfer( nDmaChannelTx, pTxTranDesc );
//DEBUGMSG(1, "%s (%d): nDmaChannelTx = %x\n",__FUNCTION__,__LINE__, nDmaChannelTx);
//
//    AT91PS_DMAC pDmac = (AT91PS_DMAC)AT91C_BASE_DMAC0;
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_SADDR = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_SADDR);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_DADDR = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_DADDR);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_DSCR = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_DSCR);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_CTRLA = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_CTRLA);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_CTRLB = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_CTRLB);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_CFG = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_CFG);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_SPIP = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_SPIP);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_DPIP = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_DPIP);
//
//    DMAD_StartTransfer( nDmaChannelTx);
//#endif

////for(;;)
//{
//DBGLINE(1,": pDmac->DMAC_EN = %x\n",pDmac->DMAC_EN);
//DBGLINE(1,": pDmac->DMAC_CHSR = %x\n",pDmac->DMAC_CHSR);
//    
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_SADDR = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_SADDR);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_DADDR = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_DADDR);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_DSCR = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_DSCR);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_CTRLA = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_CTRLA);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_CTRLB = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_CTRLB);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_CFG = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_CFG);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_SPIP = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_SPIP);
//DBGLINE(1,": pDmac->DMAC_CH[nDmaChannelTx].DMAC_DPIP = %x\n",pDmac->DMAC_CH[nDmaChannelTx].DMAC_DPIP);
////    DMAD_Handler(nDmaChannelTx);
////    if( DMAD_IsTransferDone(nDmaChannelTx) )
////        break;
////Sleep(1000);    
//}

//    CacheRangeFlush((char *)pChannelInfo->Frame.Addr, DISPLAY_STRIDE*DISPLAY_HEIGHT, CP15_SYNC_DISCARD|CP15_SYNC_L2_DISCARD);

#else
    INT32       h;
    INT32       w;
    INT32       Offset;
    UINT32*     pDst;
    UINT32*     pSrc;
 
    CHANNELINFO *pChannelInfo = ChannelInfo + Channel;

 
    Offset = DISPLAY_HEIGHT - (pRect->Xmax - pRect->Xmin + 1);
    pSrc = ((UINT32*)(pChannelInfo->Intf.Addr)) + pRect->Ymin * DISPLAY_HEIGHT + pRect->Xmin;
    for( h = pRect->Ymin; h <= pRect->Ymax; h++)
    {
        pDst = ((UINT32*)(pChannelInfo->Frame.Addr)) + pRect->Xmin * DISPLAY_WIDTH + (DISPLAY_WIDTH-1-h);
        for (w = pRect->Xmin; w <= pRect->Xmax; w++)
        {
            UINT32 vPixel;
            vPixel = *pSrc;

            *pDst = vPixel;
//            *pDst = *pSrc;
 
            pSrc++;
            pDst += DISPLAY_WIDTH;
        }

        pSrc += Offset;
    }

#endif 
    return;
}

// rotation 90 degree
STATIC VOID
GD_InvalidateRect_180( PGD pGD, PRECT pRect, UINT32 Channel )
{
    //change the hardware settings
}

// rotation 90 degree
STATIC VOID
GD_InvalidateRect_270( PGD pGD, PRECT pRect, UINT32 Channel )
{
    //change the hardware settings
}


STATIC HANDLE   hDisplay = NULL;
#define MESSAGE_DEVICE_DSP                      (32+32)
#define IOCTRL_DSP_DRVCONTROL               MESSAGE_DEFINITION(MESSAGE_DEVICE, MESSAGE_DEVICE_DSP, 2)

struct _DRVCONTROL_PARAM_
{
    UINT32  No;
    VOID *  pData;
};

STATIC BOOL
GD_DisplayDrvControl_Base( UINT32 No, PUINT32 pData )
{
#if 1


    BOOL    bRet;
    struct _DRVCONTROL_PARAM_  ControlParam;

    if( hDisplay == NULL )
        hDisplay = IoOpen( (PBYTE)"DSP1" );

    ControlParam.No = No;
    ControlParam.pData = pData;
    bRet = IoControl( hDisplay , IOCTRL_DSP_DRVCONTROL, &ControlParam, sizeof(struct _DRVCONTROL_PARAM_ *), NULL, NULL );

    return bRet;
#else
    return GD_DisplayDrvControl(No, pData);
#endif
}


#endif




STATIC BOOL
GD_DisplayDrvControl( UINT32 No, PUINT32 pData )
{
    BOOL        bRet = TRUE;

//DBGLINE(1,"No pData= (%x, %x)\n", No, pData);
    switch( No )
    {
    case GET_DISPLAY_DIRECT_SDI:
        *(SDI *)pData = ChannelInfo[CHANNEL_BASE].Frame;
//DEBUGMSG(1,"%s(%d): ChannelInfo[Channel].Frame = %x\n", __FUNCTION__ ,__LINE__,ChannelInfo[Channel].Frame.Addr);
        break;

    case SET_DISPLAY_CURSOR_CONTROL:
    {
        BOOL bOn = (BOOL)pData;

        // get the cursor layer
        CHANNELINFO *pChannelInfo = ChannelInfo + CHANNEL_CURSOR;
        pChannelInfo->bOn = (bOn != 0);
        DisplayEnableLayer( pChannelInfo );
        break;
    }

    case SET_DISPLAY_CURSOR_POSITION:
    {
        CHANNELINFO *pChannelInfo = ChannelInfo + CHANNEL_CURSOR;
        if( pChannelInfo->bOn == FALSE )
            break;

        UINT32  Param = (UINT32)pData;
        pChannelInfo->xOff = (UINT32)(Param >>  0) & 0xFFFF;
        pChannelInfo->yOff = (UINT32)(Param >> 16) & 0xFFFF;
//DBGLINE(1,"x,y = (%d, %d)\n", pChannelInfo->xOff, pChannelInfo->yOff);
        LCDD_SetPosition( pChannelInfo/*LCDD_CUR*/, pChannelInfo->xOff, pChannelInfo->yOff );
//DBGLINE(1,"x,y = (%d, %d)\n", pChannelInfo->xOff, pChannelInfo->yOff);
        break;
    }

    case DISPLAY_CHANNEL_CONTROL:
    {
        if( pData == NULL )
        {
            bRet = FALSE;
            break;
        }

        CHANNELCMD *pChannelCmd = (CHANNELCMD *)(pData);
        if( pChannelCmd->Channel >= CHANNEL_MAX)
        {
            bRet = FALSE;
            break;
        }

        if( pChannelCmd->Type == CHANNEL_CMD_CHECK_CHANNEL )
        {
            //if( pChannelCmd->Channel == CHANNEL_POPUP )
            //    bRet = FALSE;

            // support all channel...
            return bRet;
        }

        CHANNELINFO *pChannelInfo = &ChannelInfo[pChannelCmd->Channel];
        switch( pChannelCmd->Type )
        {
        case CHANNEL_CMD_GET_SDI:                // get / set the sdi of the layer
            pChannelCmd->Ret = (UINT32)&pChannelInfo->Intf;
            break;
        case CHANNEL_CMD_GET_DIRECT_SDI:                // get / set the sdi of the layer
            pChannelCmd->Ret = (UINT32)&pChannelInfo->Frame;
            break;
        case CHANNEL_CMD_SET_SDI:
            if( pChannelCmd->Param == 0)
            {
                UINT32  Frame;
                UINT32  Intf;

                UINT32 nPage = (pChannelInfo->Width * pChannelInfo->Height*4 + MEMPOOL_SIZE - 1)>>MEMPOOL_SHIFT;
//                DBGLINE(1,"nPage = %x\n", nPage);
                // create automatically
                Frame = (UINT32)MemPageAllocEx(nPage+2);
                Intf  = (UINT32)MemPageAllocEx(nPage+2);

                pChannelInfo->Frame.Addr = Frame;
                pChannelInfo->Intf.Addr  = Intf;
            }
            else
            {
                pChannelInfo->Intf = *(SDI *)pChannelCmd->Param;
            }
            break;
        case CHANNEL_CMD_GET_BASECOLOR:          // get / set the base color of the layer
            pChannelCmd->Ret = pChannelInfo->cBase;
            break;
        case CHANNEL_CMD_SET_BASECOLOR:
            pChannelInfo->cBase = (UINT32)pChannelCmd->Param;
            break;
        case CHANNEL_CMD_GET_TRANSPARENTCOLOR:   // get / set the transparent of the layer
            pChannelCmd->Ret = pChannelInfo->cTransparent;
            break;
        case CHANNEL_CMD_SET_TRANSPARENTCOLOR:
            pChannelInfo->cTransparent = (UINT32)pChannelCmd->Param;
            break;
        case CHANNEL_CMD_GET_ALPHA:              // get / set the alpha value of the layer for the blending
            pChannelCmd->Ret = pChannelInfo->Alpha;
            break;
        case CHANNEL_CMD_SET_ALPHA:
            pChannelInfo->Alpha = (UINT32)pChannelCmd->Param;
            break;
        case CHANNEL_CMD_GET_ROTATE:             // get / set the rotate angle of the layer
            pChannelCmd->Ret = pChannelInfo->RotAngle;
            break;
        case CHANNEL_CMD_SET_ROTATE:
            pChannelInfo->RotAngle = (UINT32)pChannelCmd->Param;
            break;
        case CHANNEL_CMD_GET_POS:                // get / set the position of the layer
            pChannelCmd->Ret = pChannelInfo->xOff + (pChannelInfo->yOff<<16);
            break;
        case CHANNEL_CMD_SET_POS:
            pChannelInfo->xOff = (UINT32)(pChannelCmd->Param >>  0) & 0xFFFF;
            pChannelInfo->yOff = (UINT32)(pChannelCmd->Param >> 16) & 0xFFFF;
            break;
        case CHANNEL_CMD_GET_SIZE:               // get / set the size of the layer
            pChannelCmd->Ret = pChannelInfo->Width + (pChannelInfo->Height<<16);
            break;
        case CHANNEL_CMD_SET_SIZE:
            pChannelInfo->Width  = (UINT32)(pChannelCmd->Param >>  0) & 0xFFFF;
            pChannelInfo->Height = (UINT32)(pChannelCmd->Param >> 16) & 0xFFFF;

            pChannelInfo->Frame.nBpp       = 32;  // 32 bpp
            //pChannelInfo->Frame.Addr       = 0;
            pChannelInfo->Frame.pDraw      = &Func_SDI32;

            pChannelInfo->Frame.BitMask[0] = R_MASK;  // R : 8
            pChannelInfo->Frame.BitMask[1] = G_MASK;  // G : 8
            pChannelInfo->Frame.BitMask[2] = B_MASK;  // B : 8
                                        //{0xF800, 0x07E0, 0x001F}		// R,G,B : 565

            pChannelInfo->Frame.Xres = pChannelInfo->Width;
            pChannelInfo->Frame.Yres = pChannelInfo->Height;
            pChannelInfo->Frame.nStride = pChannelInfo->Width * pChannelInfo->Frame.nBpp;
            pChannelInfo->Intf = pChannelInfo->Frame;
            break;
        case CHANNEL_CMD_GET_CONTROL:            // get / set the operation on/off
            pChannelCmd->Ret = pChannelInfo->bOn;
            break;
        case CHANNEL_CMD_SET_CONTROL:
            pChannelInfo->bOn  = (UINT32)pChannelCmd->Param;
            DisplayEnableLayer( pChannelInfo );
//DEBUGMSG(1,"%s(%d): pChannelInfo->bOn = %x\n", __FUNCTION__ ,__LINE__,pChannelInfo->bOn );
            break;
        case CHANNEL_CMD_ENABLE_TRANSPARENTCOLOR:
            pChannelInfo->bTransparent  = (UINT32)pChannelCmd->Param;
            DisplayEnableTransparent( pChannelInfo );
            break;
        case CHANNEL_CMD_ENABLE_ALPHA:
            pChannelInfo->bAlpha  = (UINT32)pChannelCmd->Param;
            DisplayEnableAlpha( pChannelInfo );
            break;
        default:
            bRet = FALSE;
            break;
        }
        break;
    }

    case SET_DISPLAY_BRIGHT:
    case SET_DISPLAY_CONTRAST:
        GD_Contrast(*pData);
        break;

    case SET_DISPLAY_BACKLIGHT:
    {
//        if( *pData )
//            GD_BacklightOn();
//        else
//            GD_BacklightOff();
        break;
    }

    case SET_DISPLAY_POWER:
    {
        if( *pData )
            GD_PowerOn();
        else
            GD_PowerOff();
        
        break;
    }

    case SET_DISPLAY_DIRECTION:
    {
        SDI *pSDI;
        int i = CHANNEL_BASE;
    	switch( *pData )
    	{
        default:
    	case DISPLAY_DIR_NORMAL:
    	    RotateAngle = 0;
            pSDI = &ChannelInfo[i].Intf;
            pSDI->Xres       = DISPLAY_WIDTH;
            pSDI->Yres       = DISPLAY_HEIGHT;
            pSDI->nStride    = DISPLAY_STRIDE;
            break;

        case DISPLAY_DIR_REVERSE:
    	    RotateAngle = 180;
            pSDI = &ChannelInfo[i].Intf;
            pSDI->Xres       = DISPLAY_WIDTH;
            pSDI->Yres       = DISPLAY_HEIGHT;
            pSDI->nStride    = DISPLAY_STRIDE;
    	    break;

    	case DISPLAY_DIR_RIGHTANGLE:
    	    RotateAngle = 90;
            pSDI = &ChannelInfo[i].Intf;
            pSDI->Xres       = DISPLAY_HEIGHT;//DISPLAY_WIDTH;
            pSDI->Yres       = DISPLAY_WIDTH;//DISPLAY_HEIGHT;
            pSDI->nStride    = pSDI->Xres*4;//DISPLAY_STRIDE;
    	    break;

    	case DISPLAY_DIR_LEFTANGLE:
    	    RotateAngle = 270;
            pSDI = &ChannelInfo[i].Intf;
            pSDI->Xres       = DISPLAY_HEIGHT;//DISPLAY_WIDTH;
            pSDI->Yres       = DISPLAY_WIDTH;//DISPLAY_HEIGHT;
            pSDI->nStride    = pSDI->Xres*4;//DISPLAY_STRIDE;
	        break;
	    }
        pSharedMemory->RotateAngle = RotateAngle;
	    break;
    }

#ifdef _HOOKRECT_
    #define SET_DISPLAY_HOOKRECT       (0x00008000) 
    case SET_DISPLAY_HOOKRECT:
        pHookInvalidateRect = pData;
        break;
#endif

    default :
        bRet = FALSE;
        break;
    }
//DEBUGMSG(1,"%s(%d): No = %X,pData = %X\n", __FUNCTION__ ,__LINE__,No, pData);
    return bRet;
}


STATIC INT32
th_Display( UINT32 Arg )
{
    JB_RECVMESSAGE      Message;
    HANDLE              hPort;
    HANDLE              Handle = NULL;
    PDEVICECONFIG       pDeviceConfig;

    pDeviceConfig = (PDEVICECONFIG)Arg;
    
    hPort = PortGet( );    
    PortSetType( hPort, PORTTYPE_MESSAGE|PORTTYPE_INTERRUPT|PORTTYPE_SIGNAL );

    pDeviceConfig->Name[3] = (UINT32)pDeviceConfig->Minor + '1';
    pDeviceConfig->Channel = ChannelGet( hPort );
    DeviceRegister( (PDEVICECONFIG)pDeviceConfig );

    while(1)
	{
		MessageReceive( hPort, &Message);
		//kprintf("%s(%d):Message.Type=%x\n",__FUNCTION__,__LINE__,Message.Type);

		switch(Message.Type)
		{
		case MESSAGE_TYPE_INTERRUPT:
		case MESSAGE_TYPE_SIGNAL:
		{
            continue;
		}

		case MESSAGE_TYPE_DEVICE_CONTROL:
	    {
            //PRECT   pRect;
            PIOCONTROL_PARAM    pIoControlParam;

            pIoControlParam = (PIOCONTROL_PARAM)Message.Param;

            Message.Type = TRUE;
		    switch( pIoControlParam->Cmd )
		    {
            case IOCTRL_DSP_DRVCONTROL:
            {
                struct _DRVCONTROL_PARAM_   *pDrvControl;
                
                pDrvControl = (struct _DRVCONTROL_PARAM_ *) pIoControlParam->pInBuf;
                Message.Type = GD_DisplayDrvControl( pDrvControl->No, pDrvControl->pData );
                break;
            }

            default:
                Message.Type = FALSE;
                break;
            }

			break;
	    }

		case MESSAGE_TYPE_DEVICE_READ:
        {
		    Message.Type = 0;
			break;
	    }

		case MESSAGE_TYPE_DEVICE_WRITE:
	    {
            Message.Type = 0;
            break;
	    }

		case MESSAGE_TYPE_DEVICE_OPEN:
        {
            Handle = ChannelOpenHandleGetFrom( pDeviceConfig->Channel );
            Message.Type = Handle;
            break;
        }

		case MESSAGE_TYPE_DEVICE_CLOSE:
        {
		    Message.Type = TRUE;
			break;
	    }

        default:
            break;
		}

        MessageReply(&Message);

	}

	return TRUE;	
}

//==========================================================================
#define DISPLAY_STACK_SIZE      (4096)

STATIC DEVICECONFIG             DisplayDeviceConfig ={"DSP", 0, -1, NULL, NULL };

STATIC THREADCONFIG             DisplayDev_Thread =
                                            {
                                                (UINT32)&DisplayDeviceConfig,
                                                th_Display,
                                                (PBYTE)NULL,
                                                DISPLAY_STACK_SIZE,
                                                THREAD_PRIORITY_DRIVER_HIGH+10
                                            };
//==========================================================================


STATIC BOOL
GD_Init_Base( VOID )
{
    STATIC BOOL bGDInitialized = FALSE;

    if( bGDInitialized )
        return TRUE;

    bGDInitialized = TRUE;
    GD_Init(CHANNEL_BASE);

    return TRUE;
}


STATIC BOOL
GD_DeInit_Base( PGD pGD )
{
    return GD_DeInit(pGD, CHANNEL_BASE);
}


    extern GD DispDrvInfo_Base;
STATIC VOID
GD_InvalidateRect_Base( PGD pGD, PRECT pRect )
{
    switch( RotateAngle )
    {
    default:
    case 0:
        GD_InvalidateRect_0(pGD, pRect, CHANNEL_BASE);
        break;
    case 90:
        GD_InvalidateRect_90(pGD, pRect, CHANNEL_BASE);
        break;
    case 180:
        //GD_InvalidateRect_180(pGD, pRect, CHANNEL_BASE);
        GD_InvalidateRect_0(pGD, pRect, CHANNEL_BASE);
        break;
    case 270:
        //GD_InvalidateRect_270(pGD, pRect, CHANNEL_BASE);
        GD_InvalidateRect_90(pGD, pRect, CHANNEL_BASE);
        break;
    }

#ifdef _HOOKRECT_
    if( pHookInvalidateRect != NULL )
    {
        pHookInvalidateRect( pRect );
    }
#endif

}




 GD DispDrvInfo_Base = 
                {
                    NULL,

                    GD_Init_Base,
                    GD_DeInit_Base,
                    GD_InvalidateRect_Base,
                    GD_DisplayDrvControl_Base,
                    GD_PowerOff,
                    GD_PowerOn
                };


#include <moduleloader.h>
PUBLIC BOOL
DllMain( HANDLE hDll, UINT32 Reason, PVOID Reserved )
{
//#ifdef _USE_THREAD_DRIVER_
    STATIC HANDLE   hThreadDisplay = NULL;
//#endif

    switch( Reason )
    {
    case DLL_PROCESS_ATTACH:
        pSharedMemory->RotateAngle = RotateAngle;
        ChannelInit();
#if 0
{
    AT91PS_MATRIX pMatrix = (AT91PS_MATRIX)(AT91C_BASE_MATRIX);

	/* Bus Matrix Master Configuration Register */
    pMatrix->MATRIX_MCFG[0] = AT91C_MATRIX_ULBT_1_BEAT; // A5
    pMatrix->MATRIX_MCFG[1] = AT91C_MATRIX_ULBT_8_BEAT; // DMAC0
    pMatrix->MATRIX_MCFG[2] = AT91C_MATRIX_ULBT_8_BEAT; // DMAC0
    pMatrix->MATRIX_MCFG[3] = AT91C_MATRIX_ULBT_8_BEAT; // DMAC0
    pMatrix->MATRIX_MCFG[4] = AT91C_MATRIX_ULBT_8_BEAT; // DMAC1
    pMatrix->MATRIX_MCFG[5] = AT91C_MATRIX_ULBT_8_BEAT; // DMAC1
    pMatrix->MATRIX_MCFG[6] = AT91C_MATRIX_ULBT_8_BEAT; // DMAC1
    pMatrix->MATRIX_MCFG[7] = AT91C_MATRIX_ULBT_4_BEAT; // GMAC
    pMatrix->MATRIX_MCFG[8] = AT91C_MATRIX_ULBT_16_BEAT; // LCDC
    pMatrix->MATRIX_MCFG[9] = AT91C_MATRIX_ULBT_16_BEAT; // LCDC
    pMatrix->MATRIX_MCFG[10] = AT91C_MATRIX_ULBT_16_BEAT; // EHCI
    pMatrix->MATRIX_MCFG[11] = AT91C_MATRIX_ULBT_16_BEAT; // OHCI
    pMatrix->MATRIX_MCFG[12] = AT91C_MATRIX_ULBT_16_BEAT; // UDP
    pMatrix->MATRIX_MCFG[13] = AT91C_MATRIX_ULBT_4_BEAT; // EMAC
    pMatrix->MATRIX_MCFG[14] = AT91C_MATRIX_ULBT_8_BEAT; // ISI

    pMatrix->MATRIX_PRAS0 = 0x11111111;
    pMatrix->MATRIX_PRBS0 = 0x11111111;
    pMatrix->MATRIX_PRAS1 = 0x11111111;
    pMatrix->MATRIX_PRBS1 = 0x11111111;
    pMatrix->MATRIX_PRAS2 = 0x11111111;
    pMatrix->MATRIX_PRBS2 = 0x11111111;
    pMatrix->MATRIX_PRAS3 = 0x11111111;
    pMatrix->MATRIX_PRBS3 = 0x11111111;
    pMatrix->MATRIX_PRAS4 = 0x11111111;
    pMatrix->MATRIX_PRBS4 = 0x11111111;
    pMatrix->MATRIX_PRAS5 = 0x11111111;
    pMatrix->MATRIX_PRBS5 = 0x11111111;
    pMatrix->MATRIX_PRAS6 = 0x11111111;
    pMatrix->MATRIX_PRBS6 = 0x11111111;
    pMatrix->MATRIX_PRAS7 = 0x11111111;
    pMatrix->MATRIX_PRBS7 = 0x11111111;
    pMatrix->MATRIX_PRAS8 = 0x33333333; //LCD
    pMatrix->MATRIX_PRBS8 = 0x33333333;
    pMatrix->MATRIX_PRAS9 = 0x33333333;
    pMatrix->MATRIX_PRBS9 = 0x33333333;
    pMatrix->MATRIX_PRAS10= 0x11111111;
    pMatrix->MATRIX_PRBS10= 0x11111111;
    pMatrix->MATRIX_PRAS11= 0x11111111;
    pMatrix->MATRIX_PRBS11= 0x11111111;
    pMatrix->MATRIX_PRAS12= 0x11111111;
    pMatrix->MATRIX_PRBS12= 0x11111111;
    pMatrix->MATRIX_PRAS13= 0x11111111;
    pMatrix->MATRIX_PRBS13= 0x11111111;
    pMatrix->MATRIX_PRAS14= 0x11111111;
    pMatrix->MATRIX_PRBS14= 0x11111111;
    pMatrix->MATRIX_PRAS15= 0x11111111;
    pMatrix->MATRIX_PRBS15= 0x11111111;

    kprintf("%s(%d): pMatrix->MATRIX_MCFG[0] = %x\n",__FUNCTION__,__LINE__,pMatrix->MATRIX_MCFG[0] );
    kprintf("%s(%d): pMatrix->MATRIX_MCFG[1] = %x\n",__FUNCTION__,__LINE__,pMatrix->MATRIX_MCFG[1] );
    kprintf("%s(%d): pMatrix->MATRIX_PRAS8 = %x\n",__FUNCTION__,__LINE__,pMatrix->MATRIX_PRAS8 );
    kprintf("%s(%d): pMatrix->MATRIX_PRBS7 = %x\n",__FUNCTION__,__LINE__,pMatrix->MATRIX_PRBS7 );

    kprintf("%s(%d): pMatrix->MATRIX_WRPROTST = %x\n",__FUNCTION__,__LINE__,pMatrix->MATRIX_WRPROTST );

}
#endif
        DispDrvInfo_Base.pSDI = &ChannelInfo[CHANNEL_BASE].Intf;

        // this fake is for rotateion : 800x800
        UINT32 YresTemp = DispDrvInfo_Base.pSDI->Yres;
        DispDrvInfo_Base.pSDI->Yres = DispDrvInfo_Base.pSDI->Xres;
        DisplayRegister (&DispDrvInfo_Base);
        DispDrvInfo_Base.pSDI->Yres = YresTemp;

//#ifdef _USE_THREAD_DRIVER_
        if( hThreadDisplay == NULL )
            hThreadDisplay = ThreadCreate( &DisplayDev_Thread );
//#endif

    	break;

    case DLL_PROCESS_DETACH:
    	break;
    }

    return hDll;
}







